/* 
   bttvgrab 0.15.10 [2000-03-21]
   (c) 1998, 1999 by Joerg Walter <trouble@moes.pmnet.uni-oldenburg.de>
   Maintained by: Joerg Walter
   Current version at http://moes.pmnet.uni-oldenburg.de/bttvgrab/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#define START_OPTIONS \
void SYMBOL(option)(const char *option, char *value, int set) \
{\
	 int num = 0, targ = -1;\
	ASSERT(option&&value,(INTMSG("null pointer passed")));\
/*	if (set) printf("%s = %s\n",option,value); */\
	if (!strcmp(option,"option name")) {\
		ASSERT(!set,(INTMSG("option name cannot be set")));\
		targ = atoi(value);
#define OPTION(x) \
	} else if (targ == num++ || !strcmp(#x,option)) {\
		if (targ == num-1) {\
			if (!set) strcpy(value,#x);\
			return;\
		}
#define O_SET else if (set)
#define O_GET else if (!set)
#define NOSET O_SET { ERROR(INTMSG("%s cannot be set"),value); END(1); }
#define FORWARD(mod,opt) do { if (set) mod ## _configure(#opt,value); else mod ## _inquire(#opt,value); } while (0)

#define OPTREDIRECT(x,mod,opt) OPTION(x) O_SET FORWARD(mod,opt); O_GET FORWARD(mod,opt)
#define INTOPTION(x,min,max) OPTION(x)\
	O_SET {\
		SYMBOL(x) = atoi(value);\
		ASSERT(SYMBOL(x) >= (min) && SYMBOL(x) <= (max),(INTMSG(#x " out of range (%i)"),SYMBOL(x)));\
	}\
	O_GET sprintf(value,"%i",SYMBOL(x));
#define INTALIAS(x,min,max,y) OPTION(x)\
	O_SET {\
		SYMBOL(y) = atoi(value);\
		ASSERT(SYMBOL(y) >= (min) && SYMBOL(y) <= (max),(INTMSG(#x " out of range (%i)"),SYMBOL(y)));\
	}\
	O_GET sprintf(value,"%i",SYMBOL(y));
#define INTINFO(x) OPTION(x) NOSET O_GET sprintf(value,"%i",SYMBOL(x))
#define BOOLOPTION(x) INTOPTION(x,0,1)
#define PTROPTION(x,nr) OPTION(x)\
	O_SET { ASSERT(!nr || SYMBOL(x),(INTMSG("access to null pointer in option " #x))); memcpy(SYMBOL(x),(void *)value,(nr) * sizeof(void *)); }\
	O_GET { ASSERT(!nr || SYMBOL(x),(INTMSG("access to null pointer in option " #x))); memcpy((void *)value,SYMBOL(x),(nr) * sizeof(void *)); }
#define PTRINFO(x,nr) OPTION(x) NOSET O_GET memcpy((void *)value,SYMBOL(x),(nr) * sizeof(void *))
#define STROPTION(x) OPTION(x) O_SET strcpy(SYMBOL(x),value); O_GET strcpy(value,SYMBOL(x))
#define STRINFO(x) OPTION(x) NOSET O_GET strcpy(value,SYMBOL(x))
#define CONSTOPTION(x,y) OPTION(x) O_SET ASSERT(!strcmp(value,y),(INTMSG(#x " cannot be changed"))); O_GET strcpy(value,y)
#define CONSTINFO(x,y) OPTION(x) NOSET O_GET strcpy(value,y)

#define LASTOPTION OPTION("option nr") NOSET O_GET sprintf(value,"%i",num-1);\
	} else {\
		ERROR(INTMSG("unknown option '%s'"),option);\
		END(1);\
	}\
}

#define END_OPTIONS LASTOPTION \
void SYMBOL(configure)(const char *option, const char *value) {	SYMBOL(option)(option,(char *)value,1); }\
void SYMBOL(inquire)(const char *option, char *value) { SYMBOL(option)(option,value,0); }

#define START_DATA \
void SYMBOL(option)(const char *format, const char *option, char *value, int set) \
{\
	 int num = 0, targ = -1;\
	ASSERT(option&&value,(INTMSG("null pointer passed")));\
	if (!strcmp(option,"option name")) {\
		ASSERT(!set,(INTMSG("option name cannot be set")));\
		targ = atoi(value);

#define END_DATA LASTOPTION \
void SYMBOL(configure)(const char *format, const char *option)\
{\
	char *v, o[2*PATH_MAX];\
	strcpy(o,option);\
	ASSERT(v = strchr(o,'='),(INTMSG("no value specified for %s"),option));\
	*v = 0;\
	SYMBOL(option)(format,o,v+1,1);\
}\
void SYMBOL(inquire)(const char *format, char *option) { SYMBOL(option)(format,option,option,0); }
