/*************************************************************************/
/*                                                                       */
/*                            LD-CELP  G.728                             */
/*                                                                       */
/*    Low-Delay Code Excitation Linear Prediction speech compression.    */
/*                                                                       */
/*    Code edited by Michael Concannon.                                  */
/*    Based on code written by Alex Zatsman, Analog Devices 1993         */
/*                                                                       */
/*************************************************************************/

#include "common.h"
/*
  This data is used by both encoder and decoder. We have to define it 
  once for cases when encoder and decoder are linked together (like ezplay).
  */

#include "common.h"

ACLASS real sound_g728_sf_coeff[LPC+1];
ACLASS real sound_g728_gp_coeff[LPCLG+1];
ACLASS real sound_g728_pwf_z_coeff[LPCW+1];
ACLASS real sound_g728_pwf_p_coeff[LPCW+1];
ACLASS real sound_g728_shape_energy[NCWD];
ACLASS real sound_g728_imp_resp[IDIM];

ACLASS real sound_g728_sf_coeff_next[LPC+1];
ACLASS real sound_g728_gp_coeff_next[LPCLG+1];
ACLASS real sound_g728_pwf_z_coeff_next[LPCW+1];
ACLASS real sound_g728_pwf_p_coeff_next[LPCW+1];
ACLASS real sound_g728_shape_energy_next[NCWD];
ACLASS real sound_g728_imp_resp_next[IDIM];

ACLASS int sound_g728_sf_coeff_obsolete_p;
ACLASS int sound_g728_gp_coeff_obsolete_p;
ACLASS int sound_g728_pwf_z_coeff_obsolete_p;
ACLASS int sound_g728_pwf_p_coeff_obsolete_p;
ACLASS int sound_g728_shape_energy_obsolete_p;
ACLASS int sound_g728_imp_resp_obsolete_p;

real sound_g728_synspeech [QSIZE];		/* Synthesized Speech */
real sound_g728_qspeech [QSIZE];		/* Quantized  Speech */
real sound_g728_log_gains[QSIZE/IDIM];	/* Logarithm of Gains */

int VOLATILE sound_g728_ffase = -4;
