/* 
   bttvgrab 0.15.10 [2000-03-21]
   (c) 1998, 1999 by Joerg Walter <trouble@moes.pmnet.uni-oldenburg.de>
   Maintained by: Joerg Walter
   Current version at http://moes.pmnet.uni-oldenburg.de/bttvgrab/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef TRANSPORT_H
#define TRANSPORT_H
#include <sys/types.h>

 extern void (*transport_itrace)(const char *s);
 extern void (*transport_otrace)(const char *s);
void transport_configure(const char *option, const char *value);
void transport_inquire(const char *option, char *value);
void transport_init();
void transport_rdetect(char *format, int *width, int *height);
void transport_srdetect(char *format);
void transport_rmkdef();
void transport_srmkdef();
void transport_swmkdef();
void transport_wmkdef();
int transport_srstart();
int transport_rstart(int multi);
int transport_swstart(const char *format);
int transport_wstart(const char *format, int width, int height, int multi);
void transport_srstop();
void transport_rstop();
void transport_wstop();
void transport_swstop();
void transport_srclose();
int transport_sread_int();
void transport_rclose();
void transport_swclose();
void transport_wclose();
void transport_end();
FILE *transport_sfwframe(int nr);
FILE *transport_fwframe(int nr);
FILE *transport_sfwstart(const char *format);
FILE *transport_fwstart(const char *format, int width, int height, int multi);
int transport_wframe(int nr);
int transport_swframe(int nr);
void transport_write(void *ptr, unsigned long cnt);
void transport_swrite(void *ptr, unsigned long cnt);
FILE *transport_frframe(int *nr);
FILE *transport_sfrframe(int *nr);
FILE *transport_frstart(int multi);
FILE *transport_sfrstart();
int transport_srframe(int *nr);
int transport_rframe(int *nr);
int transport_tryread(void *ptr, unsigned long cnt);
int transport_stryread(void *ptr, unsigned long cnt);
void transport_read(void *ptr, unsigned long cnt);
void transport_sread(void *ptr, unsigned long cnt);
void transport_rremove(int nr);
void transport_wremove(int nr);
void transport_swrite_int(int x);
void transport_write_int(int x);
int transport_read_int();
int transport_tryread_int();
void transport_swlseek(off_t offset, int whence);
void transport_srlseek(off_t offset, int whence);
void transport_unread_int(int n);
void transport_unframe();

#ifdef TRANSPORT_INTERNAL
struct transport_signature {
	unsigned char version;
	char format[80];
	int width;
	int height;
};

struct transport_ssignature {
	unsigned char version;
	char format[80];
};

void transport_rmkdef();
void transport_wmkdef();

#define TRANSPORT_CURRENT_VERSION ((unsigned char)2)

extern int transport_format;
extern int transport_sync;
extern char transport_rname[PATH_MAX];
extern char transport_wname[PATH_MAX];
extern char transport_rcname[PATH_MAX];
extern char transport_wcname[PATH_MAX];
extern int transport_rfd;
extern int transport_wfd;
extern char transport_srname[PATH_MAX];
extern char transport_swname[PATH_MAX];
extern char transport_srcname[PATH_MAX];
extern char transport_swcname[PATH_MAX];
extern int transport_srfd;
extern int transport_swfd;
extern int transport_rmulti;
extern int transport_wmulti;
extern struct transport_signature transport_rsig, transport_wsig;
extern struct transport_ssignature transport_srsig, transport_swsig;

#endif

#endif
